/*
 * generated by Xtext
 */
package de.ugoe.cs.swe.bnftools.ui;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.text.IAutoEditStrategy;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.eclipse.xtext.conversion.IValueConverterService;
import org.eclipse.xtext.ui.editor.outline.transformer.ISemanticModelTransformer;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightingConfiguration;
import org.eclipse.xtext.ui.editor.syntaxcoloring.ISemanticHighlightingCalculator;
import org.eclipse.xtext.ui.editor.syntaxcoloring.antlr.DefaultAntlrTokenToAttributeIdMapper;
import com.google.inject.Binder;

import de.ugoe.cs.swe.bnftools.ui.autoedit.EbnfAutoEditStrategy;
import de.ugoe.cs.swe.bnftools.ui.outline.EbnfTransformer;
import de.ugoe.cs.swe.bnftools.ui.syntaxcoloring.EtsiBnfAntlrTokenToAttributeMapper;
import de.ugoe.cs.swe.bnftools.ui.syntaxcoloring.EtsiBnfHighlightingConfiguration;
import de.ugoe.cs.swe.bnftools.ui.syntaxcoloring.EtsiBnfSemanticHighlightingCalculator;
import de.ugoe.cs.swe.bnftools.validation.EbnfJavaValidator;
import de.ugoe.cs.swe.bnftools.valueconverter.EbnfTerminalConverters;

/**
 * Use this class to register components to be used within the IDE.
 */
public class EbnfUiModule extends de.ugoe.cs.swe.bnftools.ui.AbstractEbnfUiModule {
	public EbnfUiModule(AbstractUIPlugin plugin) {
		super(plugin);
		EbnfUiModule.updateValidatorSettings();
	}
	
    public static void updateValidatorSettings() {
    	IPreferenceStore preferenceStore = de.ugoe.cs.swe.bnftools.ui.internal.EbnfActivator.getInstance().getPreferenceStore();
    	EbnfJavaValidator.checkReferencedOnlyOnce = preferenceStore.getBoolean("RULE_REFERENCED_ONLY_ONCE");
    	EbnfJavaValidator.checkPassthroughRule = preferenceStore.getBoolean("PASSTHROUGH_RULE");
    	EbnfJavaValidator.checkUnusedRule = preferenceStore.getBoolean("UNUSED_RULE");
    	EbnfJavaValidator.checkEqualAlternative = preferenceStore.getBoolean("EQUAL_ALTERNATIVES_RULE");
    	EbnfJavaValidator.checkDuplicateRules = preferenceStore.getBoolean("CHECK_DUPLICATE_RULES");
    	EbnfJavaValidator.checkSubruleDuplicates = preferenceStore.getBoolean("CHECK_SUBRULE_DUPLICATES");
    	EbnfJavaValidator.checkUpdatedGrammarConsistency = preferenceStore.getBoolean("CHECK_UPDATED_GRAMMAR_CONSISTENCY");
    }
	
	@Override
	public void configure(Binder binder) {
		super.configure(binder);
//		configureIResourceDescriptionsBuilderScope(binder);
//		configureIResourceDescriptions(binder);
	}
	
	public Class<? extends IHighlightingConfiguration> bindIHighlightingConfiguration() {
		return EtsiBnfHighlightingConfiguration.class;
	}

	public Class<? extends DefaultAntlrTokenToAttributeIdMapper> bindTokenToAttributeIdMapper() {
		return EtsiBnfAntlrTokenToAttributeMapper.class;
	}

	public Class<? extends ISemanticHighlightingCalculator> bindISemanticHighlightingCalculator() {
		return EtsiBnfSemanticHighlightingCalculator.class;
	}

	public Class<? extends ISemanticModelTransformer> bindISemanticModelTransformer() {
		return EbnfTransformer.class;
	}
	
	public Class<? extends IAutoEditStrategy> bindIAutoEditStrategy() {
		return EbnfAutoEditStrategy.class;
	}
	
	public Class<? extends IValueConverterService> bindIValueConverterService() {
	  return EbnfTerminalConverters.class;
	}

}
